function onLoad() {
    let blockPopState = true;
    const metaDiv = document.querySelector('span[meta]');
    const flashWrapper = document.querySelector('div[flash-wrapper]');

    const showFlash = (width, height, src) => {
        const flash = document.createElement("embed");
        flash.style.width = width + "px";
        flash.style.height = height + "px";
        flash.src = src;
		flash.setAttribute("allowScriptAccess", "sameDomain");
    		flash.setAttribute("type","application/x-shockwave-flash");
	    flash.setAttribute("pluginspage","http://www.adobe.com/go/getflash");
        flash.onload = event => console.log(event);
        flash.focus();
        flashWrapper.innerHTML = "";
        flashWrapper.appendChild(flash);
        metaDiv.style.visibility = "visible";
    };

    const reset = () => {
        metaDiv.style.visibility = "visible";
        metaDiv.textContent = "Choose from the list on the right side.";
        flashWrapper.innerHTML =
            "<h3>Good bye Flash!</h3>" +
            "<p>" +
            "Thanks for 10 years of tinkering, fiddling, bothering and lots of fun.<br>" +
            "For sentimental purpose you can watch some of my old Flash experiments here." +
            "</p>" +
            "<img src='./laboratory.png' width='512' height='256'>" +
            "<p>Sincerely André Michelle</p>";
    };

    const tonematrix = () => {
        metaDiv.style.visibility = "hidden";
        flashWrapper.innerHTML =
            "<h3>TONEMATRIX HAS A SHINY NEW URL!</h3>" +
            "<img src='./tonematrix.png' width='352' height='224'>" +
            "<a href='http://tonematrix.audiotool.com' target='tonematrix'>" +
            "Play it on Audiotool's website and import your fiddle!" +
            "</a>";
    };

    const showSWF = (work) => {
        if (work.path === "tonematrix") {
            tonematrix();
            return;
        }
        metaDiv.style.visibility = "hidden";
        metaDiv.innerHTML = work.description;
        const swf = work.swf;
        showFlash(swf.width, swf.height, swf.path);
    };

    const click = (button, work, index) => {
        return () => {
            blockPopState = false;
            button.setAttribute("visited", "");
            history.pushState({data: index}, work.title, work.path);
            showSWF(work);
        };
    };

    const workList = document.querySelector('ul[navigation]');
    const pathname = window.location.pathname;
    const path = pathname.substr(pathname.lastIndexOf("/") + 1);
    let startIndex = -1;
    let activeItem = null;
    let work = null;
    for (let index = works.length - 1; 0 <= index; --index) {
        work = works[index];
        const listItem = document.createElement("li");
        listItem.textContent = work.title;
        listItem.addEventListener("click", click(listItem, work, index));
        workList.appendChild(listItem);
        if (path === work.path) {
            activeItem = listItem;
            startIndex = index;
        }
    }
    if (-1 < startIndex) {
        work = works[startIndex];
        history.replaceState({data: startIndex}, work.title, work.path);
        activeItem.setAttribute("visited", "");
        activeItem.scrollIntoView();
        showSWF(work);
    } else {
        reset();
    }
    window.addEventListener('popstate', e => {
        // Hacking Safari's weird popstate onload bahavior
        if (blockPopState) {
            blockPopState = false;
            return;
        }
        if (null === e.state)
            reset();
        else
            showSWF(works[e.state.data]);
    }, false);
}